package drawingBoard;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Shape;
import java.awt.event.MouseEvent;
import java.awt.geom.Ellipse2D;
import java.awt.image.BufferedImage;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JPanel;

import com.smardec.mousegestures.MouseGestures;


public class DrawingBoard extends JFrame{
	
	protected static URLClassLoader urlLoader = (URLClassLoader)ClassLoader.getSystemClassLoader();
	protected static URL load(String file) {return urlLoader.findResource(file);}
	
	private static final long serialVersionUID = 1L;
	private DrawingPane contentPane=null;
	
	public DrawingBoard(){
		super();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		contentPane=new DrawingPane();
		add(contentPane);
		pack();
	}
	
	
	class DrawingPane extends JPanel {//9)
		private static final long serialVersionUID = 1L;

		private BufferedImage painting=null;
		private BufferedImage toile=null;
		
		//endroit ou l'on clique au debut de l'action
		private Point origin=null;
		
		private Vector<Shape> shapes=null;
		
		public DrawingPane(){
			
			//1)
			shapes=new Vector<Shape>();
			
			//initialisation de la taille de la fenetre à la taille de la toile
			//2)
			
			//7)
			
			//dessin du fond du tableau dans la bufferedImage painting
			paintCanvas();
			
			//ajout de l'écoute d'un nouvel evenement Gesture
			MouseGestures mouseGestures = new MouseGestures();
			mouseGestures.setMouseButton(MouseEvent.BUTTON1_MASK);
			//11)
			mouseGestures.start();
		
			//ajout de l'écoute des évènements souris
			//12)
			//12)
			
		}
		
		protected void paintCanvas(){		
			//3)
			//4)
			
			//5)
			//5)
			
			//6)
			//6)
			//6)
			//6)

		}
		
		protected void paintComponent(Graphics g){
			Graphics2D g2d=(Graphics2D)g;
			//8)
			//8)
		}
	}
	
	class Circle extends Ellipse2D.Double {
		private static final long serialVersionUID = 1L;

		public Circle(double centerX, double centerY, double radius) {
			super(centerX - radius, centerY - radius, 2.0*radius, 2.0*radius);
		}
	}
}
